import java.util.*;

public class Graph {
  // Implementation mit Adjazenzmatrix
 
  private int         anzahlKnoten, anzahlKanten;
  private boolean     istGerichtet;
  private boolean[][] adjazent;

  public Graph (int n, boolean g) {
    anzahlKnoten = n; anzahlKanten = 0;
    istGerichtet = g;
    adjazent = new boolean[n][n];
    } // Ende Konstruktor

  public int AnzahlKnoten()
    {return anzahlKnoten;}

  public int AnzahlKanten()
    {return anzahlKanten;}

  public boolean istGerichtet()
    {return istGerichtet;}

  public boolean istBenachbart (int p, int q)
    {return adjazent[p][q];}

  private void einfge (Kante k) {
    // fgt Kante in die Adjazenzmatrix ein
    int p = k.p, q = k.q;
    if (! adjazent[p][q]) anzahlKanten++;
    adjazent[p][q] = true;
    if (! istGerichtet) adjazent[q][p] = true;
    } // Ende einfge

  public void verbinde (int p, int q)
    {einfge(new Kante(p, q));}

  public void entferne (Kante k) {
    // entfernt Kante aus der Adjazenzmatrix
    int p = k.p, q = k.q;
    if (adjazent[p][q]) anzahlKanten--;
    adjazent[p][q] = false;
    if (! istGerichtet) adjazent[q][p] = false;
    } // Ende entferne

  public ArrayList Nachbarn (int p) {
    ArrayList liste = new ArrayList();
    for (int q = 0; q < anzahlKnoten; q++)
      if (adjazent[p][q]) liste.add(new Integer(q));
    return liste;
    } // Ende Nachbarn

  public int Grad (int p)
    {return Nachbarn(p).size();}

  public boolean istIsomorph (Graph g, int[] p) {
    // prft, ob this mit g unter der Abbildung p isomorph ist
    for (int i = 0; i < anzahlKnoten - 1; i++)
      for (int j = i + 1; j < g.AnzahlKnoten(); j++)
        if (adjazent[i][j] && ! g.istBenachbart(p[i], p[j]))
          return false;
    return true;
    } // Ende istIsomorph

  public boolean istGleich (Graph g) {
    for (int i = 0; i < anzahlKnoten - 1; i++)
      for (int j = i + 1; j < g.AnzahlKnoten(); j++)
        if (adjazent[i][j] && ! g.istBenachbart(i, j))
          return false;
    return true;
    } // Ende istGleich

  public String Ausgabe() {
    // gibt gesamten Graph aus
    String text = " Kn: Nachbarn\n";
    for (int p = 0; p < anzahlKnoten; p++) {
      text += " " + p + ":";
      for (int q = 0; q < adjazent[p].length; q++)
        if (adjazent[p][q]) text += " " + q;
      text += "\n";
      } // Ende for
    return text + "\n";
    } // Ende Ausgabe

  } // Ende Graph

  class Kante {
    int p, q;
    Kante (int p, int q) {this.p = p; this.q = q;}
    } // Ende Kante