import javax.swing.*;

public class BenutzerKS {
  // Benutzer-Koordinatensystem

  private double xMin, xMax, yMin, yMax;
  private double xMF, yMF;

  public BenutzerKS (double x0, double x1, double y0, double y1) {
    xMin = x0; xMax = x1; yMin = y0; yMax = y1;
    int xsMin = 10; 
    int xsMax = 410;
    int ysMin = 30;
    int ysMax = 430;
    xMF = ((double)(xsMax - xsMin)) / (xMax - xMin);
    yMF = ((double)(ysMax - ysMin)) / (yMax - yMin);
    } // Ende Konstruktor

  public BenutzerKS (JPanel p,
                     double x0, double x1, double y0, double y1) {
    xMin = x0; xMax = x1; yMin = y0; yMax = y1;
    int xsMin = 0;
    int xsMax = p.getSize().width;
    int ysMin = 0;
    int ysMax = p.getSize().height;
    xMF = ((double)(xsMax - xsMin)) / (xMax - xMin);
    yMF = ((double)(ysMax - ysMin)) / (yMax - yMin);
    } // Ende Konstruktor

  public int xS (double x)
    // transformiert x-Weltkoordinate in Bildschirmkoordinate
    {return (int) Math.round((x - xMin) * xMF);}
  
  public int yS (double y)
    // transformiert y-Weltkoordinate in Bildschirmkoordinate
    {return (int) Math.round((yMax - y) * yMF);}

  public double xW (int xs)
    // transformiert x-Bildschirmkoordinate in Weltkoordinate
    {return xMin + ((double) xs) / xMF;}

  public double yW (int ys)
    // transformiert y-Bildschirmkoordinate in Weltkoordinate
    {return yMax - ((double) ys) / yMF;}

  } // Ende BenutzerKS