import java.awt.*;
import javax.swing.*;

public class Zeichnung extends JPanel {
  // zeichnet Punkte x(n), x(n + 1) des LKG

  int multiplikator, inkrement, modul;
  int anzahlPunkte;

  public Zeichnung (int a, int b, int m, int n) {
    multiplikator = a; inkrement = b; modul = m;
    anzahlPunkte = n;
    } // Ende Konstruktor

  private int LKG (int x) {
    // linearer Kongruenzgenerator
    return (multiplikator * x + inkrement) % modul;
    } // Ende LKG

  private void zeichnePunkte (Graphics g) {
    int rand = modul / 20;
    BenutzerKS ks =
      new BenutzerKS(this, -rand, modul + rand, -rand, modul + rand);
    int x0 = 1;
    int dxy = 2;
    for (int i = 0; i < anzahlPunkte; i++) {
      int x1 = LKG(x0);
      int x2 = LKG(x1);
      g.fillRect(ks.xS(x1), ks.yS(x2), dxy, dxy);
      x0 = x1; x1 = x2;
      } // Ende for
    } // Ende zeichnePunkte

  public void paintComponent (Graphics g) {
    super.paintComponent(g);
    zeichnePunkte(g);
    } // Ende paintComponent

  } // Ende Zeichnung
